from bs4 import BeautifulSoup
from uk_bin_collection.uk_bin_collection.common import *
from uk_bin_collection.uk_bin_collection.get_bin_data import AbstractGetBinDataClass

from bs4 import BeautifulSoup
import urllib.parse
import requests
import re

class CouncilClass(AbstractGetBinDataClass):
    def parse_data(self, page: str, **kwargs) -> dict:

        data = {"bins": []}
        


        street = urllib.parse.quote_plus(kwargs.get("paon"))
        base_url = "https://www.nuneatonandbedworth.gov.uk/"
        search_query = f"directory/search?directoryID=3&showInMap=&keywords={street}&search=Search+directory"
    
        search_response = requests.get(base_url + search_query)

        if search_response.status_code == 200:
            soup = BeautifulSoup(search_response.content, 'html.parser')
            street_link_tags = soup.find_all('a', class_='list__link')
            
            street_name = kwargs.get("paon").lower()
            matches = [tag for tag in street_link_tags if street_name in tag.text.lower()]
            
            if len(matches) == 1:
                street_url = matches[0]['href']
                full_url = base_url.rstrip('/') + street_url
                bin_data = self.get_bin_data(full_url)

                for k, v in bin_data.items():
                    for date in v:
                        dict_data = {
                            "type": k,
                            "collectionDate": date
                        }
                        data["bins"].append(dict_data)
    
                return data

            elif len(matches) > 1:
                Exception("Multiple street URLs found. Please refine your search.")
            else:
                Exception("Street URL not found.")
        else:
            Exception("Failed to retrieve search results.")

        return data

    def get_bin_data(self, url) -> dict:

        bin_day_response = requests.get(url)

        if bin_day_response.status_code == 200:

            soup = BeautifulSoup(bin_day_response.content, 'html.parser')

            download_link = soup.find('a', {'href': re.compile(r'/downloads/file')})

            
            if download_link:
                file_url = download_link['href']
                filename = file_url.split('/')[-1]

                bin_data = {
  "bin-calendar-friday-b": {
    "Black Bin": [
      "2024-10-04",
      "2024-10-18",
      "2024-11-01",
      "2024-11-15",
      "2024-11-29",
      "2024-12-13",
      "2024-12-27",
      "2025-01-10",
      "2025-01-24",
      "2025-02-07",
      "2025-02-21",
      "2025-03-07",
      "2025-03-21",
      "2025-04-04",
      "2025-04-18",
      "2025-05-02",
      "2025-05-16",
      "2025-05-30",
      "2025-06-13",
      "2025-06-27",
      "2025-07-11",
      "2025-07-25",
      "2025-08-08",
      "2025-08-22",
      "2025-09-05",
      "2025-09-19"
    ],
    "Brown Bin": [
      "2024-10-11",
      "2024-10-25",
      "2024-11-08",
      "2024-11-22",
      "2024-12-06",
      "2024-12-20",
      "2025-01-03",
      "2025-01-17",
      "2025-01-31",
      "2025-02-14",
      "2025-02-28",
      "2025-03-14",
      "2025-03-28",
      "2025-04-11",
      "2025-04-25",
      "2025-05-09",
      "2025-05-23",
      "2025-06-06",
      "2025-06-20",
      "2025-07-04",
      "2025-07-18",
      "2025-08-01",
      "2025-08-15",
      "2025-08-29",
      "2025-09-12",
      "2025-09-26"
    ],
    "Green Bin": [
      "2024-10-11",
      "2024-10-25",
      "2024-11-08",
      "2024-11-22",
      "2024-12-06",
      "2024-12-20",
      "2025-01-03",
      "2025-01-17",
      "2025-02-14",
      "2025-02-28",
      "2025-03-14",
      "2025-03-28",
      "2025-04-11",
      "2025-04-25",
      "2025-05-09",
      "2025-05-23",
      "2025-06-06",
      "2025-06-20",
      "2025-07-04",
      "2025-07-18",
      "2025-08-01",
      "2025-08-15",
      "2025-08-29",
      "2025-09-12",
      "2025-09-26"
    ]
  },
  "bin-calendar-thursday-b": {
    "Black Bin": [
      "2024-10-03",
      "2024-10-17",
      "2024-10-31",
      "2024-11-14",
      "2024-11-28",
      "2024-12-12",
      "2024-12-26",
      "2025-01-09",
      "2025-01-23",
      "2025-02-06",
      "2025-02-20",
      "2025-03-06",
      "2025-03-20",
      "2025-04-03",
      "2025-04-17",
      "2025-05-01",
      "2025-05-15",
      "2025-05-29",
      "2025-06-12",
      "2025-06-26",
      "2025-07-10",
      "2025-07-24",
      "2025-08-07",
      "2025-08-21",
      "2025-09-04",
      "2025-09-18"
    ],
    "Brown Bin": [
      "2024-10-10",
      "2024-10-24",
      "2024-11-07",
      "2024-11-21",
      "2024-12-05",
      "2024-12-19",
      "2025-01-02",
      "2025-01-16",
      "2025-01-30",
      "2025-02-13",
      "2025-02-27",
      "2025-03-13",
      "2025-03-27",
      "2025-04-10",
      "2025-04-24",
      "2025-05-08",
      "2025-05-22",
      "2025-06-05",
      "2025-06-19",
      "2025-07-03",
      "2025-07-17",
      "2025-07-31",
      "2025-08-14",
      "2025-08-28",
      "2025-09-11",
      "2025-09-25"
    ],
    "Green Bin": [
      "2024-10-10",
      "2024-10-24",
      "2024-11-07",
      "2024-11-21",
      "2024-12-05",
      "2024-12-19",
      "2025-01-02",
      "2025-01-16",
      "2025-02-13",
      "2025-02-27",
      "2025-03-13",
      "2025-03-27",
      "2025-04-10",
      "2025-04-24",
      "2025-05-08",
      "2025-05-22",
      "2025-06-05",
      "2025-06-19",
      "2025-07-03",
      "2025-07-17",
      "2025-07-31",
      "2025-08-14",
      "2025-08-28",
      "2025-09-11",
      "2025-09-25"
    ]
  },
  "bin-calendar-wednesday-b": {
    "Black Bin": [
      "2024-10-02",
      "2024-10-16",
      "2024-10-30",
      "2024-11-13",
      "2024-11-27",
      "2024-12-11",
      "2024-12-25",
      "2025-01-08",
      "2025-01-22",
      "2025-02-05",
      "2025-02-19",
      "2025-03-05",
      "2025-03-19",
      "2025-04-02",
      "2025-04-16",
      "2025-04-30",
      "2025-05-14",
      "2025-05-28",
      "2025-06-11",
      "2025-06-25",
      "2025-07-09",
      "2025-07-23",
      "2025-08-06",
      "2025-08-20",
      "2025-09-03",
      "2025-09-17"
    ],
    "Brown Bin": [
      "2024-10-09",
      "2024-10-23",
      "2024-11-06",
      "2024-11-20",
      "2024-12-04",
      "2024-12-18",
      "2025-01-01",
      "2025-01-15",
      "2025-01-29",
      "2025-02-12",
      "2025-02-26",
      "2025-03-12",
      "2025-03-26",
      "2025-04-09",
      "2025-04-23",
      "2025-05-07",
      "2025-05-21",
      "2025-06-04",
      "2025-06-18",
      "2025-07-02",
      "2025-07-16",
      "2025-07-30",
      "2025-08-13",
      "2025-08-27",
      "2025-09-10",
      "2025-09-24"
    ],
    "Green Bin": [
      "2024-10-09",
      "2024-10-23",
      "2024-11-06",
      "2024-11-20",
      "2024-12-04",
      "2024-12-18",
      "2025-01-01",
      "2025-01-15",
      "2025-02-12",
      "2025-02-26",
      "2025-03-12",
      "2025-03-26",
      "2025-04-09",
      "2025-04-23",
      "2025-05-07",
      "2025-05-21",
      "2025-06-04",
      "2025-06-18",
      "2025-07-02",
      "2025-07-16",
      "2025-07-30",
      "2025-08-13",
      "2025-08-27",
      "2025-09-10",
      "2025-09-24"
    ]
  },
  "bin-calendar-tuesday-b": {
    "Black Bin": [
      "2024-10-01",
      "2024-10-15",
      "2024-10-29",
      "2024-11-12",
      "2024-11-26",
      "2024-12-10",
      "2024-12-24",
      "2025-01-07",
      "2025-01-21",
      "2025-02-04",
      "2025-02-18",
      "2025-03-04",
      "2025-03-18",
      "2025-04-01",
      "2025-04-15",
      "2025-04-29",
      "2025-05-13",
      "2025-05-27",
      "2025-06-10",
      "2025-06-24",
      "2025-07-08",
      "2025-07-22",
      "2025-08-05",
      "2025-08-19",
      "2025-09-02",
      "2025-09-16",
      "2025-09-30"
    ],
    "Brown Bin": [
      "2024-10-08",
      "2024-10-22",
      "2024-11-05",
      "2024-11-19",
      "2024-12-03",
      "2024-12-17",
      "2024-12-31",
      "2025-01-14",
      "2025-01-28",
      "2025-02-11",
      "2025-02-25",
      "2025-03-11",
      "2025-03-25",
      "2025-04-08",
      "2025-04-22",
      "2025-05-06",
      "2025-05-20",
      "2025-06-03",
      "2025-06-17",
      "2025-07-01",
      "2025-07-15",
      "2025-07-29",
      "2025-08-12",
      "2025-08-26",
      "2025-09-09",
      "2025-09-23"
    ],
    "Green Bin": [
      "2024-10-08",
      "2024-10-22",
      "2024-11-05",
      "2024-11-19",
      "2024-12-03",
      "2024-12-17",
      "2024-12-31",
      "2025-01-14",
      "2025-02-11",
      "2025-02-25",
      "2025-03-11",
      "2025-03-25",
      "2025-04-08",
      "2025-04-22",
      "2025-05-06",
      "2025-05-20",
      "2025-06-03",
      "2025-06-17",
      "2025-07-01",
      "2025-07-15",
      "2025-07-29",
      "2025-08-12",
      "2025-08-26",
      "2025-09-09",
      "2025-09-23"
    ]
  },
  "bin-calendar-monday-b": {
    "Black Bin": [
      "2024-10-14",
      "2024-10-28",
      "2024-11-11",
      "2024-11-25",
      "2024-12-09",
      "2024-12-23",
      "2025-01-06",
      "2025-01-20",
      "2025-02-03",
      "2025-02-17",
      "2025-03-03",
      "2025-03-17",
      "2025-03-31",
      "2025-04-14",
      "2025-04-28",
      "2025-05-12",
      "2025-05-26",
      "2025-06-09",
      "2025-06-23",
      "2025-07-07",
      "2025-07-21",
      "2025-08-04",
      "2025-08-18",
      "2025-09-01",
      "2025-09-15",
      "2025-09-29"
    ],
    "Brown Bin": [
      "2024-10-07",
      "2024-10-21",
      "2024-11-04",
      "2024-11-18",
      "2024-12-02",
      "2024-12-16",
      "2024-12-30",
      "2025-01-13",
      "2025-01-27",
      "2025-02-10",
      "2025-02-24",
      "2025-03-10",
      "2025-03-24",
      "2025-04-07",
      "2025-04-21",
      "2025-05-05",
      "2025-05-19",
      "2025-06-02",
      "2025-06-16",
      "2025-06-30",
      "2025-07-14",
      "2025-07-28",
      "2025-08-11",
      "2025-08-25",
      "2025-09-08",
      "2025-09-22"
    ],
    "Green Bin": [
      "2024-10-07",
      "2024-10-21",
      "2024-11-04",
      "2024-11-18",
      "2024-12-02",
      "2024-12-16",
      "2024-12-30",
      "2025-01-13",
      "2025-02-10",
      "2025-02-24",
      "2025-03-10",
      "2025-03-24",
      "2025-04-07",
      "2025-04-21",
      "2025-05-05",
      "2025-05-19",
      "2025-06-02",
      "2025-06-16",
      "2025-06-30",
      "2025-07-14",
      "2025-07-28",
      "2025-08-11",
      "2025-08-25",
      "2025-09-08",
      "2025-09-22"
    ]
  },
  "bin-calendar-friday-a": {
    "Black Bin": [
      "2024-10-11",
      "2024-10-25",
      "2024-11-08",
      "2024-11-22",
      "2024-12-06",
      "2024-12-20",
      "2025-01-03",
      "2025-01-17",
      "2025-01-31",
      "2025-02-14",
      "2025-02-28",
      "2025-03-14",
      "2025-03-28",
      "2025-04-11",
      "2025-04-25",
      "2025-05-09",
      "2025-05-23",
      "2025-06-06",
      "2025-06-20",
      "2025-07-04",
      "2025-07-18",
      "2025-08-01",
      "2025-08-15",
      "2025-08-29",
      "2025-09-12",
      "2025-09-26"
    ],
    "Brown Bin": [
      "2024-10-04",
      "2024-10-18",
      "2024-11-01",
      "2024-11-15",
      "2024-11-29",
      "2024-12-13",
      "2024-12-27",
      "2025-01-10",
      "2025-01-24",
      "2025-02-07",
      "2025-02-21",
      "2025-03-07",
      "2025-03-21",
      "2025-04-04",
      "2025-04-18",
      "2025-05-02",
      "2025-05-16",
      "2025-05-30",
      "2025-06-13",
      "2025-06-27",
      "2025-07-11",
      "2025-07-25",
      "2025-08-08",
      "2025-08-22",
      "2025-09-05",
      "2025-09-19"
    ],
    "Green Bin": [
      "2024-10-04",
      "2024-10-18",
      "2024-11-01",
      "2024-11-15",
      "2024-11-29",
      "2024-12-13",
      "2024-12-27",
      "2025-01-10",
      "2025-02-07",
      "2025-02-21",
      "2025-03-07",
      "2025-03-21",
      "2025-04-04",
      "2025-04-18",
      "2025-05-02",
      "2025-05-16",
      "2025-05-30",
      "2025-06-13",
      "2025-06-27",
      "2025-07-11",
      "2025-07-25",
      "2025-08-08",
      "2025-08-22",
      "2025-09-05",
      "2025-09-19"
    ]
  },
  "bin-calendar-thursday-a": {
    "Black Bin": [
      "2024-10-10",
      "2024-10-24",
      "2024-11-07",
      "2024-11-21",
      "2024-12-05",
      "2024-12-19",
      "2025-01-02",
      "2025-01-16",
      "2025-01-30",
      "2025-02-13",
      "2025-02-27",
      "2025-03-13",
      "2025-03-27",
      "2025-04-10",
      "2025-04-24",
      "2025-05-08",
      "2025-05-22",
      "2025-06-05",
      "2025-06-19",
      "2025-07-03",
      "2025-07-17",
      "2025-07-31",
      "2025-08-14",
      "2025-08-28",
      "2025-09-11",
      "2025-09-25"
    ],
    "Brown Bin": [
      "2024-10-03",
      "2024-10-17",
      "2024-10-31",
      "2024-11-14",
      "2024-11-28",
      "2024-12-12",
      "2024-12-26",
      "2025-01-09",
      "2025-01-23",
      "2025-02-06",
      "2025-02-20",
      "2025-03-06",
      "2025-03-20",
      "2025-04-03",
      "2025-04-17",
      "2025-05-01",
      "2025-05-15",
      "2025-05-29",
      "2025-06-12",
      "2025-06-26",
      "2025-07-10",
      "2025-07-24",
      "2025-08-07",
      "2025-08-21",
      "2025-09-04",
      "2025-09-18"
    ],
    "Green Bin": [
      "2024-10-03",
      "2024-10-17",
      "2024-10-31",
      "2024-11-14",
      "2024-11-28",
      "2024-12-12",
      "2024-12-26",
      "2025-01-09",
      "2025-02-06",
      "2025-02-20",
      "2025-03-06",
      "2025-03-20",
      "2025-04-03",
      "2025-04-17",
      "2025-05-01",
      "2025-05-15",
      "2025-05-29",
      "2025-06-12",
      "2025-06-26",
      "2025-07-10",
      "2025-07-24",
      "2025-08-07",
      "2025-08-21",
      "2025-09-04",
      "2025-09-18"
    ]
  },
  "bin-calendar-wednesday-a": {
    "Black Bin": [
      "2024-10-09",
      "2024-10-23",
      "2024-11-06",
      "2024-11-20",
      "2024-12-04",
      "2024-12-18",
      "2025-01-01",
      "2025-01-15",
      "2025-01-29",
      "2025-02-12",
      "2025-02-26",
      "2025-03-12",
      "2025-03-26",
      "2025-04-09",
      "2025-04-23",
      "2025-05-07",
      "2025-05-21",
      "2025-06-04",
      "2025-06-18",
      "2025-07-02",
      "2025-07-16",
      "2025-07-30",
      "2025-08-13",
      "2025-08-27",
      "2025-09-10",
      "2025-09-24"
    ],
    "Brown Bin": [
      "2024-10-02",
      "2024-10-16",
      "2024-10-30",
      "2024-11-13",
      "2024-11-27",
      "2024-12-11",
      "2024-12-25",
      "2025-01-08",
      "2025-01-22",
      "2025-02-05",
      "2025-02-19",
      "2025-03-05",
      "2025-03-19",
      "2025-04-02",
      "2025-04-16",
      "2025-04-30",
      "2025-05-14",
      "2025-05-28",
      "2025-06-11",
      "2025-06-25",
      "2025-07-09",
      "2025-07-23",
      "2025-08-06",
      "2025-08-20",
      "2025-09-03",
      "2025-09-17"
    ],
    "Green Bin": [
      "2024-10-02",
      "2024-10-16",
      "2024-10-30",
      "2024-11-13",
      "2024-11-27",
      "2024-12-11",
      "2024-12-25",
      "2025-01-08",
      "2025-02-05",
      "2025-02-19",
      "2025-03-05",
      "2025-03-19",
      "2025-04-02",
      "2025-04-16",
      "2025-04-30",
      "2025-05-14",
      "2025-05-28",
      "2025-06-11",
      "2025-06-25",
      "2025-07-09",
      "2025-07-23",
      "2025-08-06",
      "2025-08-20",
      "2025-09-03",
      "2025-09-17"
    ]
  },
  "bin-calendar-tuesday-a": {
    "Black Bin": [
      "2024-10-08",
      "2024-10-22",
      "2024-11-05",
      "2024-11-19",
      "2024-12-03",
      "2024-12-17",
      "2024-12-31",
      "2025-01-14",
      "2025-01-28",
      "2025-02-11",
      "2025-02-25",
      "2025-03-11",
      "2025-03-25",
      "2025-04-08",
      "2025-04-22",
      "2025-05-06",
      "2025-05-20",
      "2025-06-03",
      "2025-06-17",
      "2025-07-01",
      "2025-07-15",
      "2025-07-29",
      "2025-08-12",
      "2025-08-26",
      "2025-09-09",
      "2025-09-23"
    ],
    "Brown Bin": [
      "2024-10-01",
      "2024-10-15",
      "2024-10-29",
      "2024-11-12",
      "2024-11-26",
      "2024-12-10",
      "2024-12-24",
      "2025-01-07",
      "2025-01-21",
      "2025-02-04",
      "2025-02-18",
      "2025-03-04",
      "2025-03-18",
      "2025-04-01",
      "2025-04-15",
      "2025-04-29",
      "2025-05-13",
      "2025-05-27",
      "2025-06-10",
      "2025-06-24",
      "2025-07-08",
      "2025-07-22",
      "2025-08-05",
      "2025-08-19",
      "2025-09-02",
      "2025-09-16",
      "2025-09-30"
    ],
    "Green Bin": [
      "2024-10-01",
      "2024-10-15",
      "2024-10-29",
      "2024-11-12",
      "2024-11-26",
      "2024-12-10",
      "2024-12-24",
      "2025-01-07",
      "2025-02-04",
      "2025-02-18",
      "2025-03-04",
      "2025-03-18",
      "2025-04-01",
      "2025-04-15",
      "2025-04-29",
      "2025-05-13",
      "2025-05-27",
      "2025-06-10",
      "2025-06-24",
      "2025-07-08",
      "2025-07-22",
      "2025-08-05",
      "2025-08-19",
      "2025-09-02",
      "2025-09-16",
      "2025-09-30"
    ]
  },
  "bin-calendar-monday-a": {
    "Black Bin": [
      "2024-10-07",
      "2024-10-21",
      "2024-11-04",
      "2024-11-18",
      "2024-12-02",
      "2024-12-16",
      "2024-12-30",
      "2025-01-13",
      "2025-01-27",
      "2025-02-10",
      "2025-02-24",
      "2025-03-10",
      "2025-03-24",
      "2025-04-07",
      "2025-04-21",
      "2025-05-05",
      "2025-05-19",
      "2025-06-02",
      "2025-06-16",
      "2025-06-30",
      "2025-07-14",
      "2025-07-28",
      "2025-08-11",
      "2025-08-25",
      "2025-09-08",
      "2025-09-22"
    ],
    "Brown Bin": [
      "2024-10-14",
      "2024-10-28",
      "2024-11-11",
      "2024-11-25",
      "2024-12-09",
      "2024-12-23",
      "2025-01-06",
      "2025-01-20",
      "2025-02-03",
      "2025-02-17",
      "2025-03-03",
      "2025-03-17",
      "2025-03-31",
      "2025-04-14",
      "2025-04-28",
      "2025-05-12",
      "2025-05-26",
      "2025-06-09",
      "2025-06-23",
      "2025-07-07",
      "2025-07-21",
      "2025-08-04",
      "2025-08-18",
      "2025-09-01",
      "2025-09-15"
    ],
    "Green Bin": [
      "2024-10-14",
      "2024-10-28",
      "2024-11-11",
      "2024-11-25",
      "2024-12-09",
      "2024-12-23",
      "2025-01-06",
      "2025-02-03",
      "2025-02-17",
      "2025-03-03",
      "2025-03-17",
      "2025-03-31",
      "2025-04-14",
      "2025-04-28",
      "2025-05-12",
      "2025-05-26",
      "2025-06-09",
      "2025-06-23",
      "2025-07-07",
      "2025-07-21",
      "2025-08-04",
      "2025-08-18",
      "2025-09-01",
      "2025-09-15"
    ]
  }
}

                output = bin_data[filename]
            else:
                print(bin_day_response.content)
                Exception("Bin data Download link not found.")
                
        else:
            Exception("Failed to retrieve bin data.")
        
        return output
